/*
 * CheckURL.java
 *
 * Created on 24 September 2002, 05:56
 */

package wowg;
import java.util.*;
import java.io.*;
import java.net.*;

/**
 *
 * @author  jjc
 */
public class CheckURL {
    static private Map all = new HashMap();
    /** Creates a new instance of CheckURL */
    private String error = null;
    
    private void addError(String str) {
        if ( error == null )
            error = str;
        else
            error = error + "<br/>\n"+str;
    }
    private CheckURL(String s) {
        try {
          int dot = s.lastIndexOf('.');
          int slash = s.lastIndexOf('/');
          if ( slash < dot )
              addError("Can the suffix be removed from &lt;"+s+">?");
      //    System.err.println(s);
          URL url = new URL(s);
          String host = url.getHost();
       //   System.err.println(host);
          int lastDot = host.lastIndexOf('.');
          if (lastDot!=-1) {
      //    System.err.println(lastDot);
              int nextDot = host.lastIndexOf('.',lastDot-1);
       //   System.err.println(nextDot);
              String example = host.substring(nextDot+1,lastDot).toLowerCase();
        //  System.err.println(example);
              if ( example.equals("example") )
                  return;
          }
          if ( CachedURL.cvs != null && CachedURL.cvs.isDirectory() ) return;
          System.err.println("Checking " + s);
          URLConnection conn = url.openConnection();
          conn.connect();
          if ( conn instanceof HttpURLConnection ) {
              HttpURLConnection http = (HttpURLConnection)conn;
              if (http.getResponseCode()!=HttpURLConnection.HTTP_OK) 
                  addError("HTTP server had some problem with &lt;" + s +">: "+
                    http.getResponseMessage() );
          } else {
              InputStream in = conn.getInputStream();
              in.read();
              in.close();
          }
          
          System.err.println("Checked " + s);
          
        }
        catch (MalformedURLException e) {
            addError("URL &lt;"+s+"> is malformed: " + e.getMessage());
        }
        catch (IOException ioe) {
            addError("URL &lt;" +s+"> did not work: " + ioe.getMessage());
        }
        catch (Exception ee) {
            addError("URL &lt;" +s+"> did not work: " + ee.getMessage());
        }
    }
    static public void check(HasErrors he,String url) {
        int hash = url.lastIndexOf('#');
        if ( hash != -1 )
            url = url.substring(0,hash);
        CheckURL check = (CheckURL)all.get(url);
        if ( check == null ) {
            check = new CheckURL(url);
            all.put(url,check);
        }
        if ( check.error != null )
           he.addError(check.error);
        
    }
    static public void main(String args[]) {
        System.err.println(new CheckURL("http://www.w3.org/2002/07/owl").error);
    }
    
}
