/*
 * ImportEntailmentTest.java
 *
 * Created on 16 December 2002, 22:01
 */

package wowg;
import com.hp.hpl.jena.rdf.model.*;
import java.util.*;

/**
 *
 * @author  jjc
 */
public class ImportEntailmentTest extends wowg.PositiveEntailmentTest {
    static Property[] getProps(Resource r) {
        Vector v = new Vector();
        v.add(RTEST.premiseDocument);
        StmtIterator si = r.listProperties(OTEST.importedPremiseDocument);
        while ( si.hasNext() ) {
            si.next();
            v.add(OTEST.importedPremiseDocument);
        }
        v.add(RTEST.conclusionDocument);
        Property rslt[] = new Property[v.size()];
        v.copyInto(rslt);
        return rslt;
    }
    final Resource imports[];
    /** Creates a new instance of ImportEntailmentTest */
    public ImportEntailmentTest(Resource r) {
        super(r,getProps(r));
        imports = new Resource[getN()-2];
        int i = 0;
        StmtIterator si = r.listProperties(OTEST.importedPremiseDocument);
        while ( si.hasNext() ) {
            imports[i++] = si.nextStatement().getResource();
        }
        
    }
    
    public String getTestType() {  
         return "Import Entailment Test:";
     
    }
   
    
    public String getURI(int i) {
        int n = getN();
        if ( i == 0 || i == n-1 )
            return super.getURI(i);
        return imports[i-1].getURI();
        
    }
    
    Resource getLevelR(int i) {
        int n = getN();
        if ( i == 0 || i == n-1 )
            return super.getLevelR(i);
        return imports[i-1].hasProperty(OTEST.level)?imports[i-1].getProperty(OTEST.level).getResource():null;
        
    }
    
    public String getFileHeading(int i) {
        int n = getN();
        if ( i == 0 || i == n-1 )
            return super.getURI(i);
        return "Imported Premises";
    }
    
}
