/*
 * Manifest.java
 *
 * Created on 05 September 2002, 02:55
 */

package wowg;

import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.model.impl.*;
import com.hp.hpl.jena.vocabulary.*;
import java.util.*;

/**
 *
 * @author  jjc
 */
public class Manifest extends HasErrors {
    //    static final public String dir = root+"/2002/03owlt";
    //    static final public String tontology = "testOntology.rdf";
    //    static final public String tschema = root+"/2000/10/rdf-tests/rdfcore/testSchema.rdf";
    static final public ManifestLoader loader = new ManifestLoader(".*");
    static private Map loaders = new HashMap();
    static final public Model model() {
        //  ManifestLoader ld = (ManifestLoader)loaders.get(pattern);
        //  if ( ld == null ) {
        //      ld = new ManifestLoader(pattern);
        //      loaders.put(pattern,ld);
        //  }
        //  loader = ld;
        return loader.model();
    }
    /*
    static final public Map lookup = new HashMap();
     
    static {
        try {
            lookup.put(RDF.type,null);
            lookup.put(RDF.Property,null);
            lookup.put(RDFS.Class,null);
            lookup.put(OWL.Restriction,null);
            lookup.put(RTEST.RDF_XML_Document,null);
            lookup.put(OTEST.PositiveEntailmentTest,PositiveEntailmentTest.class.getConstructor(new Class[]{Resource.class}));
            lookup.put(OTEST.NegativeEntailmentTest,NegativeEntailmentTest.class.getConstructor(new Class[]{Resource.class}));
            lookup.put(OTEST.NotOwlFeatureTest,NotOwlFeatureTest.class.getConstructor(new Class[]{Resource.class}));
     
        }
        catch ( Exception e) {
            System.err.println(e.toString());
        }
    }
     */
/*
    static void load(File f,String uri) throws IOException, RDFException {
        if (f.getName().equals("Manifest.rdf")) {
            Reader rdf = new FileReader(f);
            model.read(rdf,uri+"Manifest");
            rdf.close();
        } else if ( f.isDirectory() ) {
            if ( f.getName().equals("CVS") )
                return;
            File ch[]=f.listFiles();
            for (int i=0;i<ch.length;i++)
                load(ch[i],uri+f.getName()+"/");
        }
    }
    static void read( String file, String url ) throws RDFException, IOException {
 
            Reader rdf = new FileReader(file);
            model.read(rdf,url);
            rdf.close();
    }
 **/
    private SortedSet acceptable = new TreeSet();
    private void addAcceptable(String s) {
        s = s.trim();
        int sp = s.indexOf(' ');
        if ( sp!= -1 ) {
            String name = s.substring(0,sp).trim();
            String number = s.substring(sp).trim();
            s = name +"/Manifest" + number;
        }
        if ( !s.startsWith("http") )
            s = "http://www.w3.org/2002/03owlt/" + s;
        if ( !s.equals("") ) {
            acceptable.add(s);
            System.err.println("+"+s);
        }
    }
    private void initAccept(String data) {
        if ( data == null || data.equals("") )
            return;
        StringTokenizer tok = new StringTokenizer(data,"\n");
        while ( tok.hasMoreElements() ){
            addAcceptable(tok.nextToken());
        }
        
    }
    private boolean accept(String uri) {
        if ( uri == null )
            return true;
      if ( acceptable.isEmpty() ) return true;
      if ( acceptable.contains(uri) ) return true;
      SortedSet smaller = acceptable.headSet(uri);
      System.err.println(uri + " > " + (smaller.isEmpty()?" empty":(" "+smaller.last())));
      if ( (!smaller.isEmpty() )
           && uri.startsWith((String)smaller.last()) )
        return true;
      return false;
    }
    
    static Collection authors = new TreeSet(new Comparator() {
        public int compare(Object o1,Object o2) {
            Comparable c1[] = (Comparable[])o1;
            Comparable c2[] = (Comparable[])o2;
            for (int i=0;i<c1.length;i++) {
                int diff = c1[i].compareTo(c2[i]);
                if ( diff != 0 )
                    return -diff;
            }
            return 0;
        }
    });
    Collection findTests(String status) throws Exception{
        Collection rslt = new HashSet();
        ResIterator  ri = model().listSubjectsWithProperty( RDF.type );
        Map authorCnt = new HashMap();
        while ( ri.hasNext() ) {
            int cnt = 0;
            Resource r = (Resource)ri.next();
            StmtIterator si = r.listProperties( RDF.type );
            while ( si.hasNext() ) {
                Resource type = (Resource)si.nextStatement().getObject();
                String uri = type.getURI();
                if ( uri.endsWith("Test") && accept(r.getURI()) ) {
                    
                    Testx t = Testx.make(r);
                    String author = t.getAuthor();
                    Integer aCnt = (Integer)authorCnt.get(author);
                    if ( aCnt == null )
                        aCnt = new Integer(0);
                    else
                        aCnt = new Integer(aCnt.intValue()+1);
                    authorCnt.put(author,aCnt);
                    if ( t == null )
                        throw new RuntimeException("Could not make Test: " + uri);
                    if ( t.getStatus().equals(status) ) {
                        rslt.add(t);
                        cnt++;
                    }
                }
                    /*
                Constructor factory = (Constructor)lookup.get(type);
                if ( factory != null ) {
                    Testx t = (Testx)factory.newInstance(new Object[]{r});
                    if ( t.getStatus().equals(status) )
                        rslt.add(t);
                    cnt++;
                } else if (! lookup.containsKey(type) ) {
                    String uri = type.getURI();
                    if ( uri.endsWith("Test") )
                        System.err.println("Not implemented - type: " + type.getURI());
                    lookup.put(type,null);
                    //  throw new RuntimeException("Not implemented - type: " + type.getURI());
                }
                     */
            }
            if (cnt>1) {
                throw new RuntimeException("Not implemented - multiple test types: " + r.getURI());
            }
            
        }
        authors.removeAll(authors);
        Iterator it = authorCnt.entrySet().iterator();
        while ( it.hasNext() ) {
            Map.Entry pair = (Map.Entry)it.next();
            authors.add(new Comparable[]{(Comparable)pair.getValue(),
                                         (Comparable)pair.getKey()});
        }
        return rslt;
    }
    /*
    void dbg() {
        System.err.println(issues.size() + " " + functions.size());
    }
     **/
    /*
    static {
        try {
          load(new File(dir),"http://www.w3.org/2002/");
          read(dir+"/"+ tontology, "http://www.w3.org/2002/03owlt/testOntology" );
          read(tschema, "http://www.w3.org/2000/10/rdf-tests/rdfcore/testSchema" );
     //     model.write(new PrintWriter(System.out),"RDF/XML-ABBREV","http://sss/");
     
        /**
          Iterator i = tests.iterator();
          while (i.hasNext()) {
              Test t = (Test)i.next();
              if ( t.feature() != null ) {
                   Collection ft = features.get(t.feature());
                   if ( ft == null ) {
                       ft = new TreeSet();
                       features.put(t.feature(),ft);
                   }
                   ft.add(t);
              }
          }
     * /
        }
        catch (Exception e) {
            System.err.println(e.toString());
        }
    }
     */
    Collection tests;
    static Comparator resComp = new Comparator() {
        public int compare(Object o1, Object o2) {
            Resource r1 = (Resource)o1;
            Resource r2 = (Resource)o2;
            return r1.getURI().compareTo(r2.getURI());
        }
    };
    Map functions = new TreeMap( resComp );
    Map issues = new TreeMap( resComp );
    SortedMap issuettes = new TreeMap( resComp );
    static SortedSet allIssuettes = new TreeSet( resComp );
    
    boolean tryAdd(Resource key, Map tbl, Testx t, String dbg ) {
        if ( key == null )
            return false;
        //    System.err.println(dbg);
        Collection ft = (Collection)tbl.get(key);
        if ( ft == null ) {
            ft = new TreeSet();
            tbl.put(key,ft);
        }
        ft.add(t);
        //  dbg();
        return true;
    }
    /** Creates a new instance of Manifest */
    public Manifest(String status,String pattern) {
        try {
            initAccept(pattern);
            tests = findTests(status);
            Iterator i = tests.iterator();
            while (i.hasNext()) {
                Testx t = (Testx)i.next();
                //    System.err.print(t.resource.getURI());
                if (! ( tryAdd(t.getFunction(),functions,t," f") 
                        || tryAdd(t.getIssue(),issues,t," i") 
                        || tryAdd(t.getIssuette(),issuettes,t," i")) )
                    System.err.println("Test with no function or issue.");
            }
            //  dbg();
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            e.printStackTrace();
            if ( e instanceof RuntimeException )
                throw (RuntimeException)e;
            else
                throw new RuntimeException("Screw up");
        }
        allIssuettes.addAll(issuettes.keySet());
    }
    
    static public String[] authors() {
        String rslt[] = new String[authors.size()];
        Iterator it = authors.iterator();
        int i=0;
        while ( it.hasNext() ) {
            rslt[i++]=(String)((Comparable[])it.next())[1];
        }
        return rslt;
    }
    public Map byFunction() {
        
        //dbg();
        /*
        Iterator it = functions.keySet().iterator();
        while ( it.hasNext() ) {
            Object k = it.next();
            System.err.println("f" + k.toString()+ " = " + ((Collection)functions.get(k)).size() );
            Iterator i2 = ((Collection)functions.get(k)).iterator();
            while (i2.hasNext()) {
                System.err.println(((Test)i2.next()).resource.getURI());
            }
        }
         **/
        
        return functions;
    }
    public Map byIssue() {
        //dbg();
        /*
        Iterator it = issues.keySet().iterator();
        while ( it.hasNext() ) {
            Object k = it.next();
            System.err.println("i " + k.toString()+ " = " + ((Collection)functions.get(k)).size() );
            Iterator i2 = ((Collection)issues.get(k)).iterator();
            while (i2.hasNext()) {
                System.err.println(((Test)i2.next()).resource.getURI());
            }
        }
         */
        return issues;
    }
    /*
    static public void main(String args[]) {
        System.err.println(new Manifest("PROPOSED").tests.size());
        System.err.println(new Manifest("APPROVED").tests.size());
        System.err.println(new Manifest(null).tests.size());
    }
     **/
    static private Resource dl = new ResourceImpl( "http://www.w3.org/TR/owl-test/#dl" );
    static private Resource extra = new ResourceImpl( "http://www.w3.org/TR/owl-test/#extra" );
    static private Resource misc = new ResourceImpl( "http://www.w3.org/TR/owl-test/#misc" );
    public Map byIssuette(String type) {
        if ( type.equals("dl") )
            return issuettes.subMap(dl,extra);
        else if ( type.equals("extra") ) 
            return issuettes.subMap(extra,misc);
        else
            return issuettes.tailMap(misc);
    }
    static public Iterator issuettes(String type) {
        Set s;
        if ( type.equals("dl") )
            s = allIssuettes.subSet(dl,extra);
        else if ( type.equals("extra") ) 
            s = allIssuettes.subSet(extra,misc);
        else
            s = allIssuettes.tailSet(misc);
        return s.iterator();
    }
    
}
