/*
 * WebCache.java
 *
 * Created on 22 September 2002, 15:13
 */

package wowg;
import java.util.*;
import java.io.*;


/**
 * This class allows creation of a value dependent upon various
 *URIs (particularly HTTP ones) and then only recomputes when the
 *(contents of) the URIs have changed.
 * @author  jjc
 */
abstract public class WebCache extends HasErrors {
    private Object value;
    private long lastUpdated;
    private Set uris; // = new HashSet();
    
    /** Creates a new instance of WebCache */
    public WebCache() {
    }
    
    boolean hasChanged()  {
        if ( uris == null )
            return true;
        Iterator it = uris.iterator();
            while ( it.hasNext() ) {
                if ( CachedURL.hasChanged((String)it.next(),lastUpdated) )
                    return true;
            }
        return false;
        
    }
    synchronized public Object value()  {
        if ( hasChanged() ) {
            lastUpdated = System.currentTimeMillis();
            uris = new HashSet();
            value = get();
        }
        return value;
    }
    boolean hasChanged(String s,long when) {
        uris.add(s);
        return CachedURL.hasChanged(s,when);
    }
    InputStream open(String s) throws IOException {
        uris.add(s);
        return CachedURL.open(s);
    }
    abstract Object get();
    
}
