/*
 * WebTriples.java
 *
 * Created on 22 September 2002, 10:20
 */

package wowg;
import java.io.*;
import java.util.*;
import com.hp.hpl.jena.rdf.model.*;

/**
 *
 * @author  jjc
 */
public class WebTriples extends Triples {
    static char startComment[] = { '<', '!', '-', '-' };
    static char endComment[] = {  '-', '-', '>' };
    
    private String commentStripped(InputStream strIn)  {
        try {
            StringBuffer rslt = new StringBuffer();
            String rsltstr;
            Reader rdr = new InputStreamReader(strIn,"utf8");
            char ch;
            int state = 0;
            int cnt = 0;
            char lookFor[] = startComment;
            char other[] = endComment;
            boolean accept = true;
            boolean acceptAll = false;
            StringBuffer tmp = new StringBuffer();
            while ( true ) {
                int ich = rdr.read();
                ch = (char)ich;
                // System.err.println(url + " " + (cnt++)+ " " + String.valueOf(ch));
                if ( ich == -1 ) {
                    rsltstr = rslt.toString().trim();
                    break;
                }
                // if ( cnt > 1300 )
                //    System.exit(1);
                if ( ch == lookFor[state] && (!acceptAll) ) {
                    state++;
                    if ( state == lookFor.length ) {
                        char xx[] = lookFor;
                        lookFor = other;
                        other = xx;
                        accept = !accept;
                        tmp.setLength(0);
                        state = 0;
                    } else {
                        if ( accept ) {
                            tmp.append(ch);
                        }
                    }
                } else if ( accept ) {
                    if ( state != 0 ) {
                        rslt.append(tmp.toString());
                        tmp.setLength(0);
                        state = 0;
                        acceptAll = true;
                    }
                    rslt.append(ch);
                } else {
                    state = 0;
                }
            }
            return// escape?escape(rsltstr):
            rsltstr;
        }
        catch (Exception e) {
            addError(e);
            return "";
        }
    }
    private class TriplesWebCache extends WebCache {
        
        String fileContents[];
        String triples[];
        Object get() {
            WebTriples.this.initNamespaces(n3);
            int N = WebTriples.super.urls.length;
            fileContents = new String[N];
            triples = new String[N];
            for (int i=0; i<N; i++) {
                triples[i] = WebTriples.super.getTriples(i);
                try {
                    fileContents[i] = commentStripped(open(urls[i]));
                }
                catch (Exception e) {
                    fileContents[i] = e.getMessage();
                }
            }
            return this;
        }
        
    }
    private TriplesWebCache inner = new TriplesWebCache();
    private boolean n3;
    static private Map all = new HashMap();
    
    static public WebTriples get(String uris[], String desc, Resource lvls[]) {
        return get(uris,desc,true,lvls);
    }
    static public WebTriples get(String uris[], String desc,boolean n3, Resource lvls[]) {
        String key = createKey(uris) +"-"+n3+"*"+Triples.usingZipMaker;
        WebTriples rslt = (WebTriples)all.get(key);
        if (rslt == null || !rslt.description.equals(desc)) {
            rslt = new WebTriples(uris,desc,n3,lvls);
            all.put(key,rslt);
        }
        rslt.inner = (TriplesWebCache) rslt.inner.value();
        return rslt;
    }
     
    static private String createKey(String u[]) {
        String k = u[0];
        for (int i=1;i<u.length;i++)
            k = k + "\t" + u[i];
        return k;
    }
    /** Creates a new instance of WebTriples */
    private WebTriples(String urls[], String descriptionx, boolean n3, Resource lvls[]) {
        super(urls,descriptionx,lvls);
        this.n3 = n3;
    }
    public String getTriples(int i) {
        if ( i >= urls.length )
            return "";
        return inner.triples[i];
    }
    public String getFile(int i) {
        if ( i >= urls.length )
            return "";
        return inner.fileContents[i];
    }
    
    InputStream getInputStream(int i) {
        return inputStream(urls[i]);
    }
    
    
    private InputStream inputStream(String url) {
        try {
            //URLConnection conn = new URL(url).openConnection();
            return CachedURL.open(url);
            
            //    Cachedconn.getInputStream();
        }
        catch (SecurityException e) {
            throw e;
        }
        catch (Exception e) {
            addError(e.getMessage());
            return null;
        }
    }
    
    boolean commentsShouldBeFound() {
        return true;
    }
    
}
