<%@page %>
<%-- This page includes all the tests in their various presentations. --%>




<%-- APPROVED TESTS --%>
<%
    tests = approved;
    useRDFXML = true;
    areNormative = true;
    prefix="approved";
    showRDFXML = true;
    showTriples = true;
%>
<%-- The approved tests--%>
<%=head(1,prefix,"The OWL Tests" + (areNormative?" (Normative)":""))%>
<%@include file="tests1.jsp" %>


<% appendix = levels[0]+1; %>
<%=head(1,"testProcess","Test Creation, Approval and Modification (Informative)")%>
<%=head(2,"creation","Creation")%>
<p>
Tests are created by members of the working group.
An (optional) 
<a href="http://www.w3.org/2002/03owlt/editors-draft/jsp/edit.jsp">
test editor</a> is provided to facilitate this.
Tests are then placed
in the appropriate directory in the 
<a href="http://www.w3.org/2002/03owlt/">test web site</a>.
This is done using CVS access to the W3C CVS server
<%=ref("W3C CVS")%>.
</p>
<p>
When created, tests are given a status of <code>"PROPOSED"</code>.
The author of the test creates a Manifest file in the directory
of the new test, identifying:
</p>
<ul>
<li>The creator of the test.</li>
<li>The test type.</li>
<li>A description of the test.</li>
<li>The RDF/XML files used in the test.</li>
<li>The status as <code>"PROPOSED"</code>.</li>
<li>At least one of:
<ul>
<li>An OWL feature that the test illustrates (by reference to the name of
some property or class in the OWL namespace).</li>
<li>An issue that the test case is related to (by reference to the issue URI
as specified in the OWL issues list <%=ref("OWL Issues")%>).</li>
<li>Some other rationale for the test.</li>
</ul>
</li>
</ul>
<%=head(2,"approval","Approval")%>
<p>At the chair's discretion, individual tests or groups of tests are put to the working group
in the weekly telecon or at a face-to-face meeting.
</p>
<p>Tests are approved by working group decision.</p>
<p>The working group may take account of favourable review
 of the tests and/or implementation reports, as well as other factors.
</p>
<p>
If the Working Group approves a test, then it is included in the test case document.
</p>
<p>
The Working Group may reject a test, in which case its status is
 changed to <code>"REJECTED"</code>. This does not indicate that the
converse of the test has been accepted. There may be stylistic
or other grounds for rejecting technically correct tests.
</p>
<p>
The Working Group has complete discretion to approve or reject tests 
independent of their conformance with this process or their conformance
with the OWL working drafts.
</p>
<p>
In the light of new information, and at the chairs' discretion, the working group
may review any previous decision regarding any test cases. The status of 
<code>"OBSOLETED"</code> may be used where a test has ceased to be appropriate.
</p>


<%=head(2,"change","Modification")%>
<p>The editors may 
make editorial changes to approved and proposed tests.
This includes:
</p>
<ul>
<li>Editorial changes to text in the test descriptions.</li>
<li>Fixing of typos and trivial errors.</li>
<li>Moving tests to conform with document naming conventions.</li>
<li>Renaming and renumbering tests and test files.</li>
<li>Substantive changes resulting from other working group decisions.</li>
<li>Stylistic changes reflecting changes to the 
<%=internal("style","preferences")%> expressed in this document. </li>
</ul>
<%=head(1,"style","Stylistic Preferences (Informative)")%>
<p>
There is a preference for the following stylistic
rules.
None of these rules is obligatory, but test authors should be 
minded that it will be easier to gain working group consensus
if they follow these rules.
</p>
<%=head(2,"rdfxml","Use of RDF/XML")%>
<p>
Tests should normally be expressed in RDF/XML.
</p>
<p>
The following RDF/XML grammar rules <%=ref("RDF/XML Syntax")%> are not used:
</p>
<ol>
<li>
<a href="http://www.w3.org/TR/rdf-syntax-grammar/#propertyAttr">Property attributes.</a>
</li>
<li>
<a href="http://www.w3.org/TR/rdf-syntax-grammar/#bagIdAttr">Bag ID.</a>
</li>
<li>
<a href="http://www.w3.org/TR/rdf-syntax-grammar/#parseTypeResourcePropertyElt"><code>rdf:parseType="Resource"</code>.</a>
</li>
</ol>
<%=head(2,"xmlbase","Use of <code>xml:base</code>")%>
<p>
Test and manifest files should have an <code>xml:base</code> attribute
<%=ref("XMLBASE")%>
on
the document element. This should show the preferred URL
of the document, from which it is actually retrievable.
</p>
<p>
Files that contain no relative URIs may omit the <code>xml:base</code> attribute.
</p>
<%=head(2,"rdfsuffix","Use of .rdf Suffix")%>
<p>
Test and manifest files should use the <code>".rdf"</code>
suffix. URIs should not. The URL used for <code>xml:base</code> declarations
does not have a suffix.
</p>

<%=head(2,"no404","Use of <code>example</code> Domains")%>
<p>
All URLs in the test and manifest files should be retrievable web resources
except for those that use domain names with <code>"example"</code> as the penultimate
component (e.g. <code>"http://www.example.org/ontology#prop"</code>).
</p>
<%=head(2,"testCopyright","Copyright")%>
<p>
The following copyright statement should be included as an XML
comment in every test file:
</p>

<pre>


&lt;!--
  Copyright World Wide Web Consortium, (Massachusetts Institute of
  Technology, European Research Consortium for Informatics and 
  Mathematics, Keio University).
 
  All Rights Reserved.
 
  Please see the full Copyright clause at
  &lt;http://www.w3.org/Consortium/Legal/copyright-software.html>

  &#36;Id: This string is updated by cvs. $
-->
</pre>

<%=head(2,"description","Description")%>
<p>
The description should:
</p>
<ul>
<li>Link to relevant parts of of the OWL recommendations. </li>
<li>Clearly distinguish syntactic and semantic concerns. </li>
</ul>
<p>The description should be included as an XML comment
in each test file, and be included as RDF content in the Manifest file.
</p>
<%=head(2,"directory","Directory Structure")%>
<p>
Tests that relate principally
to some owl property or class, should be put in a directory 
named using the local name of that property of class.
</p>
<p>
Otherwise, tests that relate to an issue should be put in a directory
named like <code>I3.4</code> where the issue number is taken from the OWL issue list
<%=ref("OWL Issues")%>.
</p>
<%=head(2,"numbering","Test Numbering")%>
<p>
Each directory should contain tests numbered consecutively from <code>001</code>.
</p>
<p>
No two tests in a single directory should have the same number.
</p>
<p>
Each file in a test should have the number of the test at the end of its name, before the suffix.
</p>
<p>
The rest of the file name should follow the conventions for the test type.
</p>
<p class="note"><strong>Note:</strong>
the approved tests in a directory will not necessarily be contiguously numbered.</p>
<p class="note"><strong>Note:</strong>
this differs from the RDF Core test case numbering conventions.</p>

<%=head(2,"n3format","Triple Format of Test Data")%>
<p>Both the approved and proposed tests
are shown both in RDF/XML, which is their normative
form, and in a triples format. This lists the triples
as subject, predicate and object, similar to the 
<a href=
"http://www.w3.org/TR/2003/WD-rdf-testcases-20030123/#ntriples">N-triples</a> format
described in <%=ref("RDF Test Cases")%>; but using qnames to
stand in for URI references.
</p>
<p>Relative URLs in the triples are with respect to the following base:
<code>http://www.w3.org/2002/03owlt/</code>.</p>
<p>
The following namespace prefixes are used throughout:
</p>
<dl>
<dt><code>rdf</code></dt><dd><code>http://www.w3.org/1999/02/22-rdf-syntax-ns#</code></dd>
<dt><code>rdfs</code></dt><dd><code>http://www.w3.org/2000/01/rdf-schema#</code></dd>
<dt><code>owl</code></dt><dd><code>http://www.w3.org/2002/07/owl#</code></dd>
<dt><code>xsd</code></dt><dd><code>http://www.w3.org/2001/XMLSchema#</code></dd>
<dt><code>first</code></dt><dd>The URL of the first file concatenated with <code>#</code>. The first file
is that named <%=named("premises")%>, <%=named("bad")%>, <%=named("consistent")%>, <%=named("inconsistent")%>
 or <%=named("imports")%> depending
on the 
<a href="#testTypes">test type</a>. (Not used for <a href="#testTrue">true tests</a> or
<a href="#testOWLforOWL">OWL for OWL tests</a>
).</dd>
<dt><code>second</code></dt><dd>The URL of the second file concatenated with <code>#</code>.
The second file is named <%=named("conclusions")%>, <%=named("nonconclusions")%> or <%=named("main")%> depending
on the 
<a href="#testTypes">test type</a>. </dd>
</dl>

<p>
In the N3 syntax <%=ref("N3")%> used for namespace declarations, 
the first four appear as follows:
</p>
     <table border="1" width="95%"
       summary="This table defines the rdf, rdfs, and owl namespace prefixes.">
     <tr><td class="TestNamespacesHead"><strong>Namespaces:</strong></td></tr>
     <tr><td class="TestNamespaces">
<pre >@prefix rdf: &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#> .
@prefix owl: &lt;http://www.w3.org/2002/07/owl#> .
@prefix xsd: &lt;http://www.w3.org/2001/XMLSchema#> .
</pre></td></tr>
</table>
<p>
Other namespaces are explicitly listed with the test data.
</p>
<%--
<p>
This section repeats the <a href="#approvedRDFXML">normative tests</a>.
</p>
<p>
This time the test data is shown in simple triples,
using N-triple syntax <%=ref("RDF Test Cases")%> with qnames.
Qnames are used in place of URIs in the syntax with no delimiters.
This syntax conforms with the usage in N3 <%=ref("N3")%>, the
namespace prefixes are also declared using N3 syntax <%=ref("N3")%>.
</p>
--%>
<%
    useRDFXML = true;
    prefix="proposed";
    tests = proposed;
%>
<%=head(1,prefix,"Proposed Tests (Informative)")%>

<%@include file="tests1.jsp" %>
<%--
<%
    useRDFXML = false;
    prefix="proposedTriples";
    showRDFXML = useRDFXML;
    showTriples = !useRDFXML;
%>

<%=head(1,prefix,"Proposed Tests as Triples (Informative)")%>
<p>
This section repeats the tests of the previous section.
</p>

<%@include file="tests1.jsp" %>
--%>
