<%@page %>
<%-- This page includes a top-level section of tests. --%>


<% if (!   useRDFXML ) { %>
<p>Relative URLs in the triples are with respect to the following base:
<code>http://www.w3.org/2002/03owlt/</code>.</p>
<p>
The following namespace prefixes are used throughout:
</p>
<dl>
<dt><code>rdf</code></dt><dd><code>http://www.w3.org/1999/02/22-rdf-syntax-ns#</code></dd>
<dt><code>rdfs</code></dt><dd><code>http://www.w3.org/2000/01/rdf-schema#</code></dd>
<dt><code>owl</code></dt><dd><code>http://www.w3.org/2002/07/owl#</code></dd>
<dt><code>xsd</code></dt><dd><code>http://www.w3.org/2005/XMLSchema#</code></dd>
<dt><code>first</code></dt><dd>The URL of the first file concatenated with <code>#</code></dd>
<dt><code>second</code></dt><dd>The URL of the second file concatenated with <code>#</code></dd>
</dl>
<p>
In the N3 syntax <%=ref("N3")%> used for namespace declarations, 
the first four appear as follows:
</p>
     <table border="1" width="95%"
       summary="This table defines the rdf, rdfs, and owl namespace prefixes.">
     <tr><td class="TestNamespacesHead"><strong>Namespaces:</strong></td></tr>
     <tr><td class="TestNamespaces">
<pre >@prefix rdf: &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
@prefix rdfs: &lt;http://www.w3.org/2000/01/rdf-schema#> .
@prefix owl: &lt;http://www.w3.org/2002/07/owl#> .
@prefix xsd: &lt;http://www.w3.org/2005/XMLSchema#> .
</pre></td></tr>
</table>
<p>
Other namespaces are explicitly listed with the test data.
</p>
<%}%>
<%=head(2,prefix+"ByFunction","By Function")%>
<% testsBy  = tests.byFunction();
   byFunction = true;
 %>
<%@include file="tests2.jsp"%>

<%=head(2,prefix+"ByIssue","By Issue")%>

<% testsBy  = tests.byIssue();
   byFunction = false;
 %>
<%@include file="tests2.jsp"%>

<% testsBy = tests.byIssuette("dl"); 
  if ( testsBy.size() > 0 ) {
%>

<%=head(2,prefix+"DL","Additional Description Logic Tests")%>
<p>
These tests are ones that are either known from the literature
(for instance, from <%=ref("Heinsohn et al.")%>),
or from test suites contributed by <!--DL implementors
(specifically from -->Network Inference.
<!--and <span class="todo">maybe someone else still</span>)-->
</p>
<p>
The following additional namespace prefix is used in this section:
</p>
<dl>
<dt><code>oiled</code></dt><dd><code>http://oiled.man.example.uk/test#</code></dd>
</dl>
<p>
In the N3 syntax <%=ref("N3")%> used for namespace declarations, 
this as as follows:
</p>
     <table border="1" width="95%"
       summary="This table defines the rdf, rdfs, and owl namespace prefixes.">
     <tr><td class="TestNamespacesHead"><strong>Namespaces:</strong></td></tr>
     <tr><td class="TestNamespaces">
<pre >@prefix oiled: &lt;http://oiled.man.ac.uk/test#> .
</pre></td></tr>
</table>
<%@include file="tests2a.jsp"%>

<%
  }
%>

<% testsBy = tests.byIssuette("misc"); 
  if ( testsBy.size() > 0 ) {
%>

<%=head(2,prefix+"Misc","Miscellaneous Tests")%>
<p>
These tests
are ones that do not fit any other category.
Some are taken from the <%=ref("OWL Guide")%>;
others reflect various aspects of OWL, that
were not formal issues addressed by the working group.
</p>
<%@include file="tests2a.jsp"%>


<%
  }
%>

<% testsBy = tests.byIssuette("extra"); 
  if ( testsBy.size() > 0 ) {
%>

<%=head(2,prefix+"ExtraCredit","Extra Credit" + (areNormative?" (Informative) ":""))%>
<p>
There is no expectation that any implementation will successfully run
the tests in this section; any that do gain extra credit.
</p>
<p>
The intent is to illustrate the semantics of OWL, particularly OWL Full,
as specified by 
<%=ref("OWL Semantics and Abstract Syntax")%>,
with the specific goal of showing that it is possible to say things
that it is not reasonable to expect an implementation to completely
understand.
</p>

<%@include file="tests2a.jsp"%>


<%
  }
%>
